#!/bin/sh
#
# Sample Torque job submition.

### Job name
#PBS -N test
### Declare job non-rerunable
#PBS -r n
### Output files
#PBS -e test.err
#PBS -o test.log
### Mail to user
#PBS -m ae
### Number of nodes
#PBS -l nodes=1:ppn=2

# This job's working directory
echo Working directory is $PBS_O_WORKDIR
cd $PBS_O_WORKDIR    

echo Running on host `hostname`
echo Time is `date`
echo Directory is `pwd`
echo This jobs runs on the following processors:
echo `cat $PBS_NODEFILE`
# Define number of processors
NPROCS=`wc -l < $PBS_NODEFILE`
echo This job has allocated $NPROCS nodes

# Run the parallel MPI executable
#For mpich2 using mpiexec with mpd
mpiexec -machinefile $PBS_NODEFILE -np $NPROCS ./cpi
#For mpich1 or mvapich using regular rsh or ssh
#mpirun -machinefile $PBS_NODEFILE -np $NPROCS ./cpi

